commit 6b4affc9d96da0f3b19d49312b1fa8572d140e0f
Author: freddy77 <freddy77>
Date:   Fri Jan 23 10:37:35 2009 +0000

    fix minor unsigned/signed issues

diff --git a/ChangeLog b/ChangeLog
index 76cc17e..7800097 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Fri Jan 23 11:35:21 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/dblib/dblib.c src/tds/query.c src/tds/write.c:
+	- fix minor unsigned/signed issues
+
 Fri Jan 23 10:42:12 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/tds/login.c: remove buffer overflow reading
 
@@ -1223,4 +1227,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2714 2009/01/23 09:42:36 freddy77 Exp $
+$Id: ChangeLog,v 1.2715 2009/01/23 10:37:35 freddy77 Exp $
diff --git a/src/dblib/dblib.c b/src/dblib/dblib.c
index 970be28..898f7a6 100644
--- a/src/dblib/dblib.c
+++ b/src/dblib/dblib.c
@@ -76,7 +76,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: dblib.c,v 1.338 2009/01/16 20:27:57 jklowden Exp $");
+TDS_RCSID(var, "$Id: dblib.c,v 1.339 2009/01/23 10:37:35 freddy77 Exp $");
 
 static RETCODE _dbresults(DBPROCESS * dbproc);
 static int _db_get_server_type(int bindtype);
@@ -1834,6 +1834,7 @@ RETCODE
 dbsetnull(DBPROCESS * dbproc, int bindtype, int bindlen, BYTE *bindval)
 {
 	BYTE *pval;
+	size_t len;
 	
 	tdsdump_log(TDS_DBG_FUNC, "dbsetnull(%p, %d, %d, %p)\n", dbproc, bindtype, bindlen, bindval);
 	
@@ -1853,21 +1854,22 @@ dbsetnull(DBPROCESS * dbproc, int bindtype, int bindlen, BYTE *bindval)
 	case SMALLDATETIMEBIND:
 	case SMALLMONEYBIND:
 	case TINYBIND:
-		bindlen = (int)default_null_representations[bindtype].len;
+		len = default_null_representations[bindtype].len;
 		break;
 
 	case CHARBIND:
 	case BINARYBIND:
 		CHECK_PARAMETER(bindlen >= 0, SYBEBBL, FAIL);
+		len = bindlen;
 		break;
 		
-	case NTBSTRINGBIND:	bindlen = (int)strlen((char *) bindval);
+	case NTBSTRINGBIND:	len = strlen((char *) bindval);
 		break;
-	case STRINGBIND:	bindlen = (int)strlen((char *) bindval);
+	case STRINGBIND:	len = strlen((char *) bindval);
 		break;
-	case VARYBINBIND:	bindlen = ((TDS_VARBINARY*) bindval)->len;
+	case VARYBINBIND:	len = ((TDS_VARBINARY*) bindval)->len;
 		break;
-	case VARYCHARBIND:	bindlen = ((TDS_VARCHAR*) bindval)->len;
+	case VARYCHARBIND:	len = ((TDS_VARCHAR*) bindval)->len;
 		break;
 
 #if 0
@@ -1879,7 +1881,7 @@ dbsetnull(DBPROCESS * dbproc, int bindtype, int bindlen, BYTE *bindval)
 		return FAIL;
 	}
 
-	if ((pval = malloc(bindlen)) == NULL) {
+	if ((pval = malloc(len)) == NULL) {
 		dbperror(dbproc, SYBEMEM, errno);
 		return FAIL;
 	}
@@ -1888,12 +1890,12 @@ dbsetnull(DBPROCESS * dbproc, int bindtype, int bindlen, BYTE *bindval)
 	if (dbproc->nullreps[bindtype].bindval != default_null_representations[bindtype].bindval)
 		free((BYTE*)dbproc->nullreps[bindtype].bindval);
 
-	memcpy(pval, bindval, bindlen);
+	memcpy(pval, bindval, len);
 	
 	dbproc->nullreps[bindtype].bindval = pval;
-	dbproc->nullreps[bindtype].len = bindlen;
+	dbproc->nullreps[bindtype].len = len;
 
-	tdsdump_dump_buf(TDS_DBG_NETWORK, "null representation set ", pval,  bindlen);
+	tdsdump_dump_buf(TDS_DBG_NETWORK, "null representation set ", pval,  len);
 	return SUCCEED;
 }
 
@@ -4607,7 +4609,7 @@ dbsqlok(DBPROCESS * dbproc)
 				}
 				break;
 #else
-				retcode = (done_flags & TDS_DONE_ERROR)? FAIL : SUCCEED;
+				int retcode = (done_flags & TDS_DONE_ERROR)? FAIL : SUCCEED;
 				dbproc->dbresults_state = (done_flags & TDS_DONE_MORE_RESULTS)?
 					_DB_RES_NEXT_RESULT : _DB_RES_NO_MORE_RESULTS;
 
diff --git a/src/tds/query.c b/src/tds/query.c
index 04828ba..59a7c44 100644
--- a/src/tds/query.c
+++ b/src/tds/query.c
@@ -46,7 +46,7 @@
 
 #include <assert.h>
 
-TDS_RCSID(var, "$Id: query.c,v 1.229 2009/01/16 20:27:58 jklowden Exp $");
+TDS_RCSID(var, "$Id: query.c,v 1.230 2009/01/23 10:37:36 freddy77 Exp $");
 
 static void tds_put_params(TDSSOCKET * tds, TDSPARAMINFO * info, int flags);
 static void tds7_put_query_params(TDSSOCKET * tds, const char *query, size_t query_len);
@@ -55,7 +55,7 @@ static int tds_put_data_info(TDSSOCKET * tds, TDSCOLUMN * curcol, int flags);
 static int tds_put_data(TDSSOCKET * tds, TDSCOLUMN * curcol);
 static char *tds7_build_param_def_from_query(TDSSOCKET * tds, const char* converted_query, size_t converted_query_len, TDSPARAMINFO * params, size_t *out_len);
 static char *tds7_build_param_def_from_params(TDSSOCKET * tds, const char* query, size_t query_len, TDSPARAMINFO * params, size_t *out_len);
-static int tds_fix_column_size(TDSSOCKET * tds, TDSCOLUMN * curcol);
+static size_t tds_fix_column_size(TDSSOCKET * tds, TDSCOLUMN * curcol);
 
 static int tds_send_emulated_execute(TDSSOCKET * tds, const char *query, TDSPARAMINFO * params);
 static const char *tds_skip_comment(const char *s);
@@ -131,21 +131,19 @@ tds_convert_string(TDSSOCKET * tds, const TDSICONV * char_conv, const char *s, i
 
 	CHECK_TDS_EXTRA(tds);
 
-	if (len < 0)
-		len = (int)strlen(s);
+	il = len < 0 ? strlen(s) : len;
 	if (char_conv->flags == TDS_ENCODING_MEMCPY) {
-		*out_len = len;
+		*out_len = il;
 		return s;
 	}
 
 	/* allocate needed buffer (+1 is to exclude 0 case) */
-	ol = len * char_conv->server_charset.max_bytes_per_char / char_conv->client_charset.min_bytes_per_char + 1;
+	ol = il * char_conv->server_charset.max_bytes_per_char / char_conv->client_charset.min_bytes_per_char + 1;
 	buf = (char *) malloc(ol);
 	if (!buf)
 		return NULL;
 
 	ib = s;
-	il = len;
 	ob = buf;
 	memset(suppress, 0, sizeof(char_conv->suppress));
 	if (tds_iconv(tds, char_conv, to_server, &ib, &il, &ob, &ol) == (size_t)-1) {
@@ -349,7 +347,7 @@ tds_submit_query_params(TDSSOCKET * tds, const char *query, TDSPARAMINFO * param
 			 * TODO perhaps functions that calls tds7_build_param_def_from_query
 			 * should call also tds7_build_param_def_from_params ??
 			 */
-			param_definition = tds7_build_param_def_from_query(tds, converted_query, (int)converted_query_len, params, &definition_len);
+			param_definition = tds7_build_param_def_from_query(tds, converted_query, converted_query_len, params, &definition_len);
 			if (!param_definition) {
 				tds_set_state(tds, TDS_IDLE);
 				return TDS_FAIL;
@@ -614,8 +612,9 @@ static int
 tds_get_column_declaration(TDSSOCKET * tds, TDSCOLUMN * curcol, char *out)
 {
 	const char *fmt = NULL;
-	int max_len = IS_TDS7_PLUS(tds) ? 8000 : 255;
-	int size;
+	/* unsigned int is required by printf format, don't use size_t */
+	unsigned int max_len = IS_TDS7_PLUS(tds) ? 8000 : 255;
+	unsigned int size;
 
 	CHECK_TDS_EXTRA(tds);
 	CHECK_COLUMN_EXTRA(curcol);
@@ -625,11 +624,11 @@ tds_get_column_declaration(TDSSOCKET * tds, TDSCOLUMN * curcol, char *out)
 	switch (tds_get_conversion_type(curcol->on_server.column_type, curcol->on_server.column_size)) {
 	case XSYBCHAR:
 	case SYBCHAR:
-		fmt = "CHAR(%d)";
+		fmt = "CHAR(%u)";
 		break;
 	case SYBVARCHAR:
 	case XSYBVARCHAR:
-		fmt = "VARCHAR(%d)";
+		fmt = "VARCHAR(%u)";
 		break;
 	case SYBINT1:
 		fmt = "TINYINT";
@@ -674,11 +673,11 @@ tds_get_column_declaration(TDSSOCKET * tds, TDSCOLUMN * curcol, char *out)
 		break;
 	case SYBBINARY:
 	case XSYBBINARY:
-		fmt = "BINARY(%d)";
+		fmt = "BINARY(%u)";
 		break;
 	case SYBVARBINARY:
 	case XSYBVARBINARY:
-		fmt = "VARBINARY(%d)";
+		fmt = "VARBINARY(%u)";
 		break;
 	case SYBNUMERIC:
 		fmt = "NUMERIC(%d,%d)";
@@ -700,16 +699,16 @@ tds_get_column_declaration(TDSSOCKET * tds, TDSCOLUMN * curcol, char *out)
 	case SYBNVARCHAR:
 	case XSYBNVARCHAR:
 		if (IS_TDS7_PLUS(tds)) {
-			fmt = "NVARCHAR(%d)";
+			fmt = "NVARCHAR(%u)";
 			max_len = 4000;
-			size /= 2;
+			size /= 2u;
 		}
 		break;
 	case XSYBNCHAR:
 		if (IS_TDS7_PLUS(tds)) {
-			fmt = "NCHAR(%d)";
+			fmt = "NCHAR(%u)";
 			max_len = 4000;
-			size /= 2;
+			size /= 2u;
 		}
 		break;
 		/* nullable types should not occur here... */
@@ -731,7 +730,7 @@ tds_get_column_declaration(TDSSOCKET * tds, TDSCOLUMN * curcol, char *out)
 
 	if (fmt) {
 		/* fill out */
-		sprintf(out, fmt, size > 0 ? (size > max_len ? max_len : size) : 1);
+		sprintf(out, fmt, size > 0 ? (size > max_len ? max_len : size) : 1u);
 		return TDS_SUCCEED;
 	}
 
@@ -950,7 +949,7 @@ tds7_put_query_params(TDSSOCKET * tds, const char *query, size_t query_len)
 	tds_put_byte(tds, 0);
 	tds_put_byte(tds, 0);
 	tds_put_byte(tds, SYBNTEXT);	/* must be Ntype */
-	len = 2 * len + query_len;
+	len = 2u * len + query_len;
 	TDS_PUT_INT(tds, len);
 	if (IS_TDS8_PLUS(tds))
 		tds_put_n(tds, tds->collation, 5);
@@ -1077,7 +1076,7 @@ tds_submit_prepare(TDSSOCKET * tds, const char *query, const char *id, TDSDYNAMI
 		tds_put_byte(tds, 0);
 
 		tds7_put_params_definition(tds, param_definition, definition_len);
-		tds7_put_query_params(tds, converted_query, (int)converted_query_len);
+		tds7_put_query_params(tds, converted_query, converted_query_len);
 		tds_convert_string_free(query, converted_query);
 		free(param_definition);
 
@@ -1267,15 +1266,15 @@ tds_submit_execdirect(TDSSOCKET * tds, const char *query, TDSPARAMINFO * params)
 /**
  * Get column size for wire
  */
-static int
+static size_t
 tds_fix_column_size(TDSSOCKET * tds, TDSCOLUMN * curcol)
 {
-	int size = curcol->on_server.column_size, min;
+	size_t size = curcol->on_server.column_size, min;
 
 	if (!size) {
 		size = curcol->column_size;
 		if (is_unicode_type(curcol->on_server.column_type))
-			size *= 2;
+			size *= 2u;
 	}
 
 	switch (curcol->column_varint_size) {
@@ -1290,13 +1289,13 @@ tds_fix_column_size(TDSSOCKET * tds, TDSCOLUMN * curcol)
 			min = 2;
 		else
 			min = 1;
-		size = MAX(MIN(size, 8000), min);
+		size = MAX(MIN(size, 8000u), min);
 		break;
 	case 4:
 		if (curcol->on_server.column_type == SYBNTEXT)
-			size = MAX(MIN(size, 0x7ffffffe), 2);
+			size = MAX(MIN(size, 0x7ffffffeu), 2u);
 		else
-			size = MAX(MIN(size, 0x7fffffff), 1);
+			size = MAX(MIN(size, 0x7fffffffu), 1u);
 		break;
 	}
 /*	return curcol->on_server.column_size = size; */
@@ -1358,7 +1357,7 @@ tds_put_data_info(TDSSOCKET * tds, TDSCOLUMN * curcol, int flags)
 	tds_put_byte(tds, curcol->column_output);	/* status (input) */
 	if (!IS_TDS7_PLUS(tds))
 		tds_put_int(tds, curcol->column_usertype);	/* usertype */
-	// FIXME: column_type is wider than one byte.  Do something sensible, not just lop off the high byte. 
+	/* FIXME: column_type is wider than one byte.  Do something sensible, not just lop off the high byte. */
 	tds_put_byte(tds, curcol->on_server.column_type);
 
 	if (is_numeric_type(curcol->on_server.column_type)) {
@@ -1373,7 +1372,7 @@ tds_put_data_info(TDSSOCKET * tds, TDSCOLUMN * curcol, int flags)
 		tds_put_byte(tds, num->scale);
 #endif
 	} else {
-		int size = tds_fix_column_size(tds, curcol);
+		size_t size = tds_fix_column_size(tds, curcol);
 		switch (curcol->column_varint_size) {
 		case 0:
 			break;
@@ -1442,17 +1441,16 @@ tds_put_data(TDSSOCKET * tds, TDSCOLUMN * curcol)
 	unsigned char *src;
 	TDS_NUMERIC *num;
 	TDSBLOB *blob = NULL;
-	TDS_INT colsize, size;
+	size_t colsize, size;
 
 	CHECK_TDS_EXTRA(tds);
 	CHECK_COLUMN_EXTRA(curcol);
 
-	colsize = curcol->column_cur_size;
 	src = curcol->column_data;
 
 	tdsdump_log(TDS_DBG_INFO1, "tds_put_data: colsize = %d\n", (int) colsize);
 
-	if (colsize < 0) {
+	if (curcol->column_cur_size < 0) {
 		tdsdump_log(TDS_DBG_INFO1, "tds_put_data: null param\n");
 		switch (curcol->column_varint_size) {
 		case 4:
@@ -1469,6 +1467,7 @@ tds_put_data(TDSSOCKET * tds, TDSCOLUMN * curcol)
 		}
 		return TDS_SUCCEED;
 	}
+	colsize = curcol->column_cur_size;
 
 	size = tds_fix_column_size(tds, curcol);
 
@@ -2100,9 +2099,6 @@ tds_cursor_declare(TDSSOCKET * tds, TDSCURSOR * cursor, TDSPARAMINFO *params, in
 int
 tds_cursor_open(TDSSOCKET * tds, TDSCURSOR * cursor, TDSPARAMINFO *params, int *something_to_send)
 {
-	size_t converted_query_len;
-	const char *converted_query;
-
 	CHECK_TDS_EXTRA(tds);
 
 	if (!cursor)
@@ -2134,7 +2130,8 @@ tds_cursor_open(TDSSOCKET * tds, TDSCURSOR * cursor, TDSPARAMINFO *params, int *
 		*something_to_send = 1;
 	}
 	if (IS_TDS7_PLUS(tds)) {
-		size_t definition_len = 0;
+		const char *converted_query;
+		size_t definition_len = 0, converted_query_len;
 		char *param_definition = NULL;
 		int num_params = params ? params->num_cols : 0;
 
diff --git a/src/tds/write.c b/src/tds/write.c
index 5e70c56..1eb1d1a 100644
--- a/src/tds/write.c
+++ b/src/tds/write.c
@@ -49,7 +49,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: write.c,v 1.77 2009/01/16 20:27:59 jklowden Exp $");
+TDS_RCSID(var, "$Id: write.c,v 1.78 2009/01/23 10:37:36 freddy77 Exp $");
 
 /**
  * \addtogroup network
@@ -66,8 +66,6 @@ tds_put_n(TDSSOCKET * tds, const void *buf, size_t n)
 	size_t left;
 	const unsigned char *bufp = (const unsigned char *) buf;
 
-	assert(n >= 0);
-
 	for (; n;) {
 		left = tds->env.block_size - tds->out_pos;
 		if (left <= 0) {
@@ -149,7 +147,7 @@ tds_put_string(TDSSOCKET * tds, const char *s, int len)
 				tdsdump_log(TDS_DBG_NETWORK, "Error: tds_put_string: "
 							     "Gave up converting %d bytes due to error %d.\n", 
 							     (int) inbytesleft, errno);
-				tdsdump_dump_buf(TDS_DBG_NETWORK, "Troublesome bytes", s, (int) inbytesleft);
+				tdsdump_dump_buf(TDS_DBG_NETWORK, "Troublesome bytes", s, inbytesleft);
 			}
 
 			if (poutbuf == outbuf) {	/* tds_iconv did not convert anything, avoid infinite loop */

